"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useGoogleReCaptchaV3 = useGoogleReCaptchaV3;
var _react = require("react");
var _useScript3 = _interopRequireDefault(require("./useScript"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function useGoogleReCaptchaV3({
  siteKey,
  disabled = false
}) {
  // Load ReCaptcha script.
  const _useScript = (0, _useScript3.default)(`https://www.google.com/recaptcha/api.js?render=${siteKey}`, disabled),
    _useScript2 = _slicedToArray(_useScript, 2),
    loaded = _useScript2[0],
    error = _useScript2[1];
  (0, _react.useEffect)(() => {
    if (loaded && !disabled) {
      // eslint-disable-next-line no-console
      console.log('Google ReCaptcha script loaded!');
    }
    if (error) throw new Error('Google ReCaptcha script failed to load');
  }, [loaded, error, disabled]);
  const executeReCaptcha = (0, _react.useCallback)( /*#__PURE__*/function () {
    var _ref = _asyncToGenerator(function* (action) {
      if (!window) {
        throw new Error('ERROR: NOT A WEB BROWSER');
      }
      if (disabled) {
        return Promise.resolve(undefined);
      }
      const _window = window,
        grecaptcha = _window.grecaptcha;
      if (!grecaptcha) {
        throw new Error('ERROR: SCRIPT NOT AVAILABLE');
      }
      return new Promise(resolve => {
        // Invoke the ReCaptcha check.
        grecaptcha.ready(() => {
          grecaptcha.execute(siteKey, {
            action
          }).then(token => {
            resolve(token);
          });
        });
      });
    });
    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }(), [siteKey, disabled]);
  return executeReCaptcha;
}