declare global {
    interface Window {
        grecaptcha: any;
    }
}
export declare type GoogleReCaptchaV3Options = {
    /**
     * The `sitekey` to use with reCAPTCHA v3.
     * https://developers.google.com/recaptcha/docs/v3
     */
    siteKey: string;
    /**
     * Disable ReCaptcha preventing the script from loading and return undefined from the execute function.
     * This is useful when consumer needs to conditionally enable or disable ReCaptcha
     */
    disabled?: boolean;
};
export declare function useGoogleReCaptchaV3({ siteKey, disabled }: GoogleReCaptchaV3Options): (action?: string) => Promise<string | undefined>;
